package net.hostsharing.hsadminng.test.cust;

import net.hostsharing.hsadminng.rbac.rbacdef.RbacViewMermaidFlowchart;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;

class TestCustomerEntityTest {

    @Test
    void definesRbac() {
        final var rbacFlowchart = new RbacViewMermaidFlowchart(TestCustomerEntity.rbac()).toString();
        assertThat(rbacFlowchart).isEqualTo("""
                %%{init:{'flowchart':{'htmlLabels':false}}}%%
                flowchart TB
                                
                subgraph customer["`**customer**`"]
                    direction TB
                    style customer fill:#dd4901,stroke:darkblue,stroke-width:8px
                
                    subgraph customer:roles[ ]
                        style customer:roles fill: #dd4901
                    
                        role:customer:owner[[customer:owner]]
                        role:customer:admin[[customer:admin]]
                        role:customer:tenant[[customer:tenant]]
                    end
                
                    subgraph customer:permissions[ ]
                        style customer:permissions fill: #dd4901
                    
                        perm:customer:*{{customer:*}}
                        perm:customer:add-package{{customer:add-package}}
                        perm:customer:view{{customer:view}}
                    end
                end
                
                %% granting roles to users
                user:creator ==> role:customer:owner

                %% granting roles to roles
                role:global:admin ==> role:customer:owner
                role:customer:owner ==> role:customer:admin
                role:customer:admin ==> role:customer:tenant
                
                %% granting permissions to roles
                role:customer:owner ==> perm:customer:*
                role:customer:admin ==> perm:customer:add-package
                role:customer:tenant ==> perm:customer:view
                """);
    }
}
